;By Arnold Jagt  POB 372 Burlington, Ontario, Canada  L7R 3Y3
;Placed on CompuServe BorApp Forum,  Apr. 3 1989.  
;The following procs are not by themselves a working system.
;They are several procs out of a working system which I have modified somewhat
;and extracted because of their more or less generic nature.
;You will probably profit most from the following procs by including them in
;your own scripts after studying them carefully - noting all the variables
;and how they are used.  Otherwise just browse around.


RUN "del paradox.lib"  ;DELETE the old library - delete this and the following line if you already use "paradox" lib file

CREATELIB "paradox"    ;create a new one

;The following proc is an enhanced version of the one in the LAPALS newsletter
;See the menu*.db files that are included in this arc file for examples
;of the table structures it will work with.

PROC OVMenu(name)                            	;Begin procedure definition
    PRIVATE                                     ;Make these variables local
    def,num_rec,item,expl,action_,action_type,action_argument,escape_clause,admin_menu

;Use the name "menusyst" for the table containing the menu maintainence menu choice
;making it accesible only to those users who have a security level ("s_level") of
;administrator ("adm").  Thus, assign everyone an "s_level", making the administrator's
;equal to "adm".  The variable "menu_dir_path" is used for the path of the directory
;where all your menu tables are located.


    IF name="menusyst" AND s_level<>"adm"       ;check to see if user is system administrator
        THEN display_message("Only the System Administrator may access this menu")
             RETURN                             ;"menusyst" is a reserved (for adminiatrator) menu selection
    ENDIF

    escape_clause=FALSE                             ;set escape clause TO FALSE
    VIEW menu_dir_path+name                         ;Open the TABLE with the MENU info
    num_rec=NRECORDS(menu_dir_path+name)            ;Count the number of MENU selections

    ARRAY item[num_rec]                          	;Declare ARRAY FOR selections
    ARRAY expl[num_rec]                          	;Declare ARRAY FOR explanations
    ARRAY action_[num_rec]                              ;Declare ARRAY FOR actions
    ARRAY action_argument[num_rec]               	;Declare ARRAY FOR action_argument
    ARRAY action_type[num_rec]                   	;Declare ARRAY FOR TYPE of action
    def=1                                        	;Set MENU DEFAULT TO first item

    SCAN
        counter=RECNO()                            	;LOOP through TABLE
        item[counter]=[MenuChoice]                 	;Put MENU selection into ARRAY
        expl[counter]=[MenuDescription]            	;Put description into ARRAY
        action_[counter]=[MenuAction]                   ;Put action into ARRAY
        action_argument[counter]=[MenuActionArgument] 	;Put the argument inot ARRAY
        action_type[counter]=[MenuActionType]      	;Put TYPE of action into ARRAY
    ENDSCAN                                      	;END of LOOP

    CLEARIMAGE                                   	;CLEAR the MENU TABLE

    WHILE escape_clause=FALSE                    	;SELECTION LOOP
        CLEAR                                   	;CLEAR the screen
        SHOWARRAY item expl                     	;Display the MENU
            DEFAULT item[def]                       	;SELECT the DEFAULT
        TO menu_sel                             	;Save response in menu_sel
        IF menu_sel="Quit" THEN end_it()                ;IF they choose Leave THEN end_it()
        ENDIF                                           ;END of IF
        IF menu_sel="Exit" OR                   	;IF they choose EXIT
            menu_sel="Return" OR                 	;RETURN OR
            menu_sel="Esc"                       	;is user hits ESC key
            AND NOT name="menumain"              	;AND is NOT at the top MENU
           THEN                                         ;THEN
            RETURN                               	; RETURN TO the previous script/MENU
                                                        ; THIS IS THE EXIT FROM THE LOOP
           ELSE
            IF menu_sel="Esc"                       ;User has press ESC at the
                AND name="menumain"                 ;mainmenu
               THEN
                LOOP                                ;no can leave
            ENDIF
        ENDIF                                   	;END of IF
        FOR counter FROM 1 TO num_rec           	;SCAN FOR item chosen
            IF menu_sel=item[counter] THEN        	;IF the chosen selection is found..
                def=counter                        	;assign DEFAULT TO item chosen AND
                QUITLOOP                                ;QUIT the FOR LOOP
            ENDIF                                 	;END of IF
        ENDFOR                                  	;END of the FOR LOOP

        SWITCH
            CASE action_type[counter]="Menu":     	;IF the item chosen was another menu..
                IF ISTABLE(menu_dir_path+action_[counter]);check to make sure it exists
                    THEN OVMenu(action_[counter])        ;Start the MENU again (Note RECURSION)
                    ELSE display_message("Table "+action_[counter]+" not found")
                ENDIF

            CASE action_type[counter]="NotDefined" OR IF ISBLANK(action_type[counter]):
                display_message("Not Defined Yet")	;Item is NOT defined yet
                LOOP                            	;LOOP TO show MENU

            CASE action_type[counter]="DataEntry":	;Carry out the procedure FOR dataentry
                x=form_number
                form_number=action_argument[counter]
                DEntry(action_[counter])                 ;ON the TABLE referred TO
                form_number=x

            CASE action_type[counter]="Command":  	;carry out an actual command
                EXECUTE action_[counter]+" "+action_argument[counter]

            CASE action_type[counter]="CoEdit":   	;COEDIT a TABLE
                IF ISTABLE(action_[counter])             ;check to make sure it exists
                    THEN current_table=action_[counter]  ;
BEEP SLEEP 5000;this is where my edit script goes; sb_edit(current_table)         ;EDIT the TABLE in action
                    ELSE display_message("Table "+action_[counter]+" not found")
                ENDIF

            CASE action_type[counter]="Report":   	;Generate a REPORT
                IF ISFILE(action_[counter]+".f"+action_argument[counter]) ;check to make sure it exists
                    THEN REPORT action_[counter] action_argument[counter] ;play if so else tell user
                    ELSE display_message("Report "+action_[counter]+" not found")
                ENDIF

            CASE action_type[counter]="Script":   	;RUN a script
                IF ISFILE(action_[counter]+".sc")        ;check to make sure it exists
                    THEN PLAY action_[counter]           ;play if so else tell user
                    ELSE display_message("Script "+action_[counter]+" not found")
                ENDIF

            CASE action_type[counter]="Procedure":	;RUN a procedure
                EXECUTE action_[counter]+"("+action_argument[counter]+")"

            OTHERWISE:
                LOOP

        ENDSWITCH
    ENDWHILE                                    ;END of SELECTION LOOP (NOT an EXIT)
ENDPROC                                         ;END of procedure MENU
WRITELIB "paradox" OVMenu
RELEASE PROCS ALL



PROC maintain_aux(dosfilename)      ;maintainence proc for the administrators benefit
PRIVATE dosfilename,file_chosen ;keep from re-using the same menu
IF NOT ISFILE(menu_dir_path+dosfilename) THEN
   display_message("File "+dosfilename+" doesn't exist") RETURN
ENDIF
WHILE true
SHOWFILES NOEXT menu_dir_path+dosfilename "Chose the table/script you wish to work with"
          TO file_chosen
    IF file_chosen="Esc" THEN RETURN        ;Esc if user hits the Esc key
    ENDIF
SWITCH
    CASE MATCH(action_argument[counter],"..db\""):         ;work on a menu table
         simple_edit(menu_dir_path+file_chosen)
    OTHERWISE: RUN BIG "q "+menu_dir_path+file_chosen
ENDSWITCH
ENDWHILE
ENDPROC
WRITELIB "paradox" maintain_aux
RELEASE PROCS ALL



PROC maintain_aj(dosfilename)      ;maintainence proc for the administrators benefit
PRIVATE dosfilename,file_chosen ;keep from re-using the same menu
IF NOT ISFILE(dosfilename) THEN
   display_message("File "+dosfilename+" doesn't exist") RETURN
ENDIF
WHILE true
SHOWFILES NOEXT dosfilename "Chose the table/script you wish to work with"
          TO file_chosen
    IF file_chosen="Esc" THEN RETURN        ;Esc if user hits the Esc key
    ENDIF
SWITCH
    CASE MATCH(action_argument[counter],"..db\""):         ;work on a menu table
         simple_edit(aj_system_path+file_chosen)
    OTHERWISE: RUN BIG "q "+file_chosen
ENDSWITCH
ENDWHILE
ENDPROC
WRITELIB "paradox" maintain_aj
RELEASE PROCS ALL

PROC maintain_aux_text(dosfilename)      ;maintainence proc for the administrators benefit
PRIVATE dosfilename,file_chosen ;keep from re-using the same menu
IF NOT ISFILE(menu_dir_path+dosfilename) THEN
   display_message("File "+dosfilename+" doesn't exist") RETURN
ENDIF
WHILE true
SHOWFILES menu_dir_path+dosfilename "Chose the table/script you wish to work with"
          TO file_chosen
    IF file_chosen="Esc" THEN RETURN        ;Esc if user hits the Esc key
    ENDIF
SWITCH
    CASE MATCH(action_argument[counter],"..db\""):         ;work on a menu table
         display_message("Only text files can be displayed by this proc");simple_edit(menu_dir_path+file_chosen)
    OTHERWISE: RUN BIG "q "+menu_dir_path+file_chosen
ENDSWITCH
ENDWHILE
ENDPROC
WRITELIB "paradox" maintain_aux_text
RELEASE PROCS ALL

PROC maintain_aj_text(dosfilename)      ;maintainence proc for the administrators benefit
PRIVATE dosfilename,file_chosen ;keep from re-using the same menu
IF NOT ISFILE(aj_system_path+dosfilename) THEN
   display_message("File "+dosfilename+" doesn't exist") RETURN
ENDIF
WHILE true
SHOWFILES aj_system_path+dosfilename "Chose the table/script you wish to work with"
          TO file_chosen
    IF file_chosen="Esc" THEN RETURN        ;Esc if user hits the Esc key
    ENDIF
SWITCH
    CASE MATCH(action_argument[counter],"..db\""):         ;work on a menu table
         display_message("Only text files can be displayed by this proc");simple_edit(menu_dir_path+file_chosen)
    OTHERWISE: RUN BIG "q "+aj_system_path+file_chosen
ENDSWITCH
ENDWHILE
ENDPROC
WRITELIB "paradox" maintain_aj_text
RELEASE PROCS ALL


PROC simple_edit(file_chosen)
         CLEAR
         CLEARALL
         COEDIT file_chosen
         @ 0,0 CLEAR EOL
         @ 1,0 CLEAR EOL
         WAIT TABLE
            PROMPT "NoteEscF2",
                   "  This record may be locked while you are here   Return Save & edit another "
         UNTIL "F2","Esc"

         SWITCH
            CASE RETVAL = "Esc":                ;User wishes TO post records
                KEYPRESS 21                     ;Undo the last change
                DO_IT!                          ;Do it
                CLEARALL
                CLEAR
                RETURN                          ;AND go ON

            CASE RETVAL = "F2" :
                DO_IT!
                CLEARALL
                CLEAR
         ENDSWITCH
         PROMPT ;get rid of prompt

ENDPROC
WRITELIB "paradox" simple_edit
RELEASE PROCS ALL


;The following is an example of a script I use to assign security
;It is placed here solely for observation only.

PROC startup()          ;this sets all the nessecary variables used by the system
PRIVATE x,              ;declare these variables as private
aj_system_path,

;Security matters

    VIEW "Contactr"                      	;bring UP an image of TABLE
    MOVETO [Contactr->Contactor_Code]    	;move TO the RIGHT FIELD
    LOCATE c_code                        	;LOCATE the proper RECORD
    IF RETVAL=FALSE
        THEN splash("Unauthorized User")  	;this is just a double CHECK
        EXIT
    ENDIF
    s_level=[Contactr->Employer]        	;set the secuirty level based ON the
                                                ;users Employer
    CLEARALL
    SWITCH
        CASE s_level="adm"   :     ;the administrator's system level
            form_number=1                    ;"everyone" is the password for
            PASSWORD "ccuanews","everyone"   ;access to the system - keeps them encrypted
            security_code="..@@@.."          ;but available

        CASE s_level="O&Y"   :     ;O&Y employees
            form_number=1
            PASSWORD "everyone"
            security_code="..O&Y.."

        CASE s_level="DTC"   :     ;DTC employees
            form_number=1
            PASSWORD "everyone"
            security_code="..DTC.."

        CASE s_level="JLW"    :     ;JLW employees
            form_number=1
            PASSWORD "everyone"
            security_code="..JLW.."

        ENDSWITCH


;set gloabal variables

    Errorproc="error_procedure" ;set the customized error handler

    IF ISFILE("savevars.sc")    ;retrieve old variables since they contain
        THEN PLAY "savevars"    ;reusable "habituale" locations
    ENDIF

    VIEW menu_dir_path+"startup";set up the golbal variblae from a table called "startup"
         SCAN
              SWITCH
                  CASE [Var_Type]="D":  ;Type is Date
                       EXECUTE [Var_Name]+"=[Var_Value_Date]"
                  CASE [Var_Type]="A":  ;Type is Alpha
                       EXECUTE [Var_Name]+"=[Var_Value_Alpha]"
                  CASE [Var_Type]="N":  ;Type is Number
                       EXECUTE [Var_Name]+"=[Var_Value_Number]"
              ENDSWITCH
         ENDSCAN
    CLEARIMAGE

    SETSWAP swap_size           ;set swaping to begin when swap_size bytes left
                                ;helps avoid out of memory message


;set up the next table varibales (lets user jump from table to table with one key
;when used with a special procedure

    VIEW menu_dir_path+"tablnext"  ;bring UP the tablnext TABLE TO assign the "next" tables
    SCAN                              ;so the "F4" NEXT TABLE command will work properly
        EXECUTE [This_table_leads]+"="+"\""+[To_this_table]+"\""
    ENDSCAN
    CLEARIMAGE

;set check_required_fields() array

    VIEW menu_dir_path+"required"  ;Scan in the array to start
    MOVETO [Field_Name]
    x=NRECORDS(menu_dir_path+"required")
    ARRAY req[x]
    x=1
    SCAN
      req[x]=[]
      x=x+1
    ENDSCAN
    CLEARIMAGE


; Start the application

ovmenu("menumain")

ENDPROC
WRITELIB "paradox" startup
RELEASE PROCS ALL


PROC special_altn_key()
PRIVATE x,y,temp_contents

   SWITCH

    CASE FIELDTYPE()="N" AND []=BLANKNUM() AND FIELD()<>"Amount_of_Space_Leased" AND FIELD()<>"Current_Requirements_Size":
      IF FIELDTYPE()="N"
        THEN x=CMAX(TABLE(),FIELD())
        IF x="Error" THEN x=0
        ENDIF []=x+1
      ENDIF

    CASE FIELDTYPE()="D":
      IF FIELDTYPE()="D" THEN []=TODAY()
      ENDIF

    CASE SUBSTR(FIELDTYPE(),1,1)="A" AND MATCH(FIELD(),"..Time.."):
      IF SUBSTR(FIELDTYPE(),1,1)="A" AND MATCH(FIELD(),"..Time..") THEN []=FORMAT("W5",TIME())
      ENDIF


   ENDSWITCH
ENDPROC
WRITELIB "paradox" special_altn_key
RELEASE PROCS ALL

PROC coedit_next_table()         ;this PROC simply converts a varibale TO its value
        ;(which is itself a varibable, AND so ON - see startup() AND "TABLNEXT"
    EXECUTE "current_table="+"\""+TABLE()+"\""
    EXECUTE "EXECUTE \"current_table=\"+"+"\""+current_table+"\""

ENDPROC
WRITELIB "paradox" coedit_next_table
RELEASE PROCS ALL


PROC end_it()
            SAVEVARS
                Security_Level,
            CLEARALL
            UNPASSWORD "ccuanews", "everyone"
            RESET
            IF s_level="adm" THEN QUIT                      ; QUIT Paradox!
            ELSE EXIT
            ENDIF
ENDPROC
WRITELIB "paradox" end_it
RELEASE PROCS ALL


PROC retlocat()  	;moves TO the dynamically set FIELD location
    PRIVATE x
    x=FIELD()
    IF ISFORMVIEW() THEN FORMKEY ENDIF
    MOVETO [#] RIGHT
    EXECUTE "IF ISASSIGNED (" + FIELD() + ") THEN LOCATE " + FIELD() + " ENDIF"
    MOVETO FIELD x
    FORMKEY
ENDPROC
WRITELIB "paradox" retlocat
RELEASE PROCS ALL


PROC savlocat()
PRIVATE x
    IF FIELD()="Company_Reference" THEN Company_Reference=[] ENDIF
    x=FIELD()
    IF ISFORMVIEW() THEN FORMKEY ENDIF
    MOVETO [#] RIGHT
;this section of code assigns a value TO the variable name represented by the cuurent FIELD name
;when retlocat is called it will return you to the next field with the savlocat value
    IF FIELD()<>"#" AND RECNO()<>0    ;don't bother IF there isn't even a RECORD in the TABLE OR IF in the RECNO column
        THEN
        IF NOT FIELDSTR()="" AND NOT FIELDSTR()=BLANKNUM() AND NOT FIELDSTR()=BLANKDATE()       ;don't bother IF the FIELD is blank
            THEN
            IF SUBSTR(FIELDTYPE(),1,1) = "A"                 ;IF its an Alpha FIELD
                THEN EXECUTE FIELD()+"=STRVAL([])" ;put some quotes around it since it is a string
            ELSE EXECUTE FIELD()+"="+FIELDSTR()    ;ELSE leave it as a value
            ENDIF
        ENDIF
    ENDIF
    MOVETO FIELD x
    FORMKEY
ENDPROC
WRITELIB "paradox" savlocat
RELEASE PROCS ALL


PROC save_Field_default()
PRIVATE x,y

    savlocat()  ;set the vlaue of 1st  image col for retlocat()
;This section of code will assign a value TO a FIELD

    IF FIELD()="#" THEN     ;of course it does not work in the # col
        RETURN
    ENDIF
    x=TABLE()               ;save present locale
    y=FIELD()
    MOVETO [Var->Field_Name];goto the car table
    LOCATE y                ;locate the field name record
    MOVETO x                ;go back to the original table
       SWITCH
          CASE SUBSTR(FieldType(),1,1) = "A" :   ;IF its an Alpha FIELD
              [Var->Alpha_Value]=[]
          CASE SUBSTR(FieldType(),1,1) = "N" :   ;IF its an Number FIELD
              [Var->Number_Value]=[]
          CASE SUBSTR(FieldType(),1,1) = "D" :   ;IF its an Date FIELD
              [Var->Date_Value]=[]
       ENDSWITCH                                 ;assign value to the proper type of field
    PICKFORM form_number                         ;moving between table loses the form
                                                 ;so call it back
ENDPROC
WRITELIB "paradox" save_Field_default
RELEASE PROCS ALL



PROC retrieve_Field_default()
PRIVATE x,y
        x=TABLE()                   ;store present locale
        y=FIELD()
        MOVETO [Var->Field_Name]    ;move to existing var image
        LOCATE y                    ;locate the field name record
        MOVETO x                    ;go back to the original table
        SWITCH
          CASE SUBSTR(FieldType(),1,1) = "A" :   ;IF its an Alpha FIELD
              field_default=[Var->Alpha_Value]
          CASE SUBSTR(FieldType(),1,1) = "N" :   ;IF its an Number FIELD
              field_default=[Var->Number_Value]
          CASE SUBSTR(FieldType(),1,1) = "D" :   ;IF its an Date FIELD
              field_default=[Var->Date_Value]
        ENDSWITCH                                ;get value from the proper type of field
        STYLE REVERSE
        STYLE ATTRIBUTE 2
        @1,2
        ? "Field Default =\""+STRVAL(field_default)+"\"  Press Enter to Accept"
        keycode=GETCHAR()                      ;WAIT FOR the user TO indicate his choice
        STYLE                                  ;show TO the user
        IF keycode=13                          ;IF the user accepts it THEN
            THEN []=Field_default              ;assign the value TO the FIELD
;           ELSE KEYPRESS keycode              ;IF NOT accepted THEN pass ON the keystroke - This caused some problems when [F1] was pressed
        ENDIF
        PICKFORM form_number                   ;moving between table loses the form
                                               ;so call it back
ENDPROC
WRITELIB "paradox" retrieve_Field_default
RELEASE PROCS ALL

PROC check_required_fields()
PRIVATE x,y,lf,pf
pf=FIELD()         ;remember the present field
badreq=false       ;set badreq variable to false
x=ARRAYSIZE(req)   ;set the array size
CTRLEND            ;goto the last field
lf=FIELD()         ;grab its name
CTRLHOME           ;go to the first field
WHILE FIELD()<>lf  ;until you get to the end...
FOR y FROM 1 TO x  ;go through the array
  IF FIELD()=req[y] THEN   ;see if this is a good one to check
     IF ISBLANK([]) THEN badreq=true
        display_message("You need to fill in "+req[y]+" to complete record")
        RETURN     ;if so then see
     ENDIF         ;if its blank
  ENDIF            ;if so then set badreq to true, display_message and return
ENDFOR
RIGHT              ;move to the next field
ENDWHILE
MOVETO FIELD pf    ;move back to the original field

ENDPROC
WRITELIB "paradox" check_required_fields
RELEASE PROCS ALL


PROC splash(text_message)   	; SPLASH SCREEN

    CLEAR
    @ 3,0
TEXT
    
    ߱
                                                                   
      
                                                                 
    
    ı
                                                           
    ı
                                                                   
                                               ı
                                                                   
                                               ı
                        
    ı
                                                           
    ı
    
      Copyright (c) 1989                              All Rights Reserved


ENDTEXT
    STYLE REVERSE
    @ 13,19 ?? FORMAT("w41,ac",text_message)
    @ 0,0
    STYLE

ENDPROC
WRITELIB "paradox" splash
RELEASE PROCS ALL



INFOLIB "paradox"
